#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mpi.h>

double sqrt();

double vol(double x, double y);
main(int argc, char* argv[])
{
  int n = 4;
  int p;
  MPI_Comm grid_comm;
  int dim_sizes[2];
  int wrap_around[2];
  int reorder = 1;
  int coordinates[2];
  int my_grid_rank;
  int q;
  double re[4];
  double startx;
  double starty;
  double endx;
  double endy;

  double x;
  double y;

  double h;
  double pisquared;
  int i,j;  


  MPI_Init(&argc, &argv);
  MPI_Comm_size(MPI_COMM_WORLD, &p);

  q = sqrt(p);
  dim_sizes[0] = dim_sizes[1] = q;
  
  wrap_around[0] = wrap_around[1] = 1;  
  MPI_Cart_create(MPI_COMM_WORLD, 2, dim_sizes, wrap_around, reorder, &grid_comm);
  MPI_Comm_rank(grid_comm, &my_grid_rank);
  MPI_Cart_coords(grid_comm, my_grid_rank, 2, coordinates);

  h = 1/(double)n;
  startx = (double)coordinates[0]/(double)q;
  starty = (double)coordinates[1]/(double)q;
  endx = (double)coordinates[0]/(double)q + 0.5; 
  endy = (double)coordinates[1]/(double)q + 0.5; 

  for (x=startx; x<endx; x+=h)
  { for (y=starty; y<endy; y+=h)
    { pisquared += (h*h) * (vol(x,y) + vol(x,y+h) + vol(x+h,y) + vol(x+h,y+h))/4;
     }
  }
  pisquared = 16 * pisquared;
  MPI_Gather(&pisquared, 1, MPI_DOUBLE, &re, 1, MPI_DOUBLE, 0, grid_comm);
  if(my_grid_rank == 0)
  { pisquared = 0.0; 
    for(i = 0; i < p; i++)
     pisquared +=  re[i];
     printf("The value of pi squared is %.16f\n", pisquared);
     printf("The value of pi is %.16f\n", sqrt(pisquared));    
  }
MPI_Finalize();
}

double vol(double x, double y)
{  return (double)1/((1.0 +x*x) *(1.0 + y*y));
}

